unit mappedfiles;

interface

uses
  Windows, Messages, SysUtils, Classes,  Dialogs;

procedure OpenMappedFile( MapName:string );
procedure CloseMappedFile;
function  ReadFromMappedFile( MapName:string ):string;
procedure WriteToMappedFile(Text:string);
    
var
  DLLInstance: THandle;


implementation


procedure OpenMappedFile( MapName:string );
type
 TOpenMap =  procedure( MapName:string );
var
 OpenMap : TOpenMap;
begin
 (* Load Dll *)
 DLLInstance := LoadLibrary( 'mapped.dll' ); //- Directory of DLL
 If DLLInstance = 0 then begin
   MessageDlg( 'Unable to load DLL.',mtError,[mbOK],0 );
   Halt;
   Exit;
 end;
 (* Open Mapped File *)
 @OpenMap := GetProcAddress( DLLInstance, 'OpenMap' );
 If @OpenMap <> nil then
    OpenMap( MapName )
 else
 begin
    MessageDlg( 'Unable to Open Map', mtError, [mbOK],0 );
    Halt;
    Exit;
 end;
end;


procedure CloseMappedFile;
type
  TCloseMap=  procedure;
var
  CloseMap : TCloseMap;
begin
 @CloseMap := GetProcAddress(DLLInstance,'CloseMap');
  If @CloseMap <> nil then
     CloseMap
 else
 begin
   MessageDlg('Unable to Close Map', mtError,[mbOK],0);
   Halt;
   Exit;
 end;
 FreeLibrary(DLLInstance);
end;

procedure WriteToMappedFile(Text:string);
type
 TWriteMap=  procedure( text:string );
var
 WriteMap : TWriteMap;
begin
 @WriteMap := GetProcAddress(DLLInstance,'WriteMap');
 If @WriteMap <> nil then
   WriteMap(text)
 else
   MessageDlg('Unable Write to Map', mtError,[mbOK],0);
end;

function ReadFromMappedFile(MapName:string):string;
type
 TReadMap=  function( MapName:string ):pchar;
var
 ReadMap : TReadMap;
begin
 @ReadMap := GetProcAddress(DLLInstance,'ReadMap');
 If @ReadMap <> nil then
 begin
   Result := pchar(ReadMap(MapName));
 end
 else
   MessageDlg('Unable Read From Map', mtError,[mbOK],0);
end;

end.
